#include <stdio.h>


/* Function prototypes */

int check_file (FILE* input, int sequence_bank_offset);
int rip_sequences (FILE *input, int seqcount, int sequence_bank_offset);

/* Global variables and structs */

int seq_count;

struct sequence {
       int start_offset;
       int lenght;
       } sequence_list[150];

/* Functions */

int check_file (FILE* input, int sequence_bank_offset)  /* Check if first bytes are 0x000300 = rev number */
{
    
char ch1, ch2, ch3;

fseek(input, sequence_bank_offset, SEEK_SET);
ch1 = getc(input);
ch2 = getc(input);
ch3 = getc(input);

  if ( ch1 == 0 && ch2 == 0x03 && ch3 == 0)   {
       
     return 1;    /* valid file */
       
     }
     
  else  {
        return 0; /* wrong file */
        }
    
}

int rip_sequences (FILE *input, int seqcount, int sequence_bank_offset)
{
    
char filename[14];
char ch;
int i, j;
int byte1, byte2, byte3, byte4;
int offset;
  
fseek(input, ((sequence_bank_offset) + 4), SEEK_SET);  
  
    for (i = 0; i < seqcount; i++)   {
    
    /* There's probably a better way for doing this */ 
    
    fseek(input, ((sequence_bank_offset) + 4 + (8 * i) ), SEEK_SET); 
    
    byte1 = fgetc(input);
    byte2 = fgetc(input);
    byte3 = fgetc(input);
    byte4 = fgetc(input);            
    sequence_list[i].start_offset = (byte1 << 24) + (byte2 << 16) + (byte3 << 8) + byte4;
   
    byte1 = fgetc(input);
    byte2 = fgetc(input);
    byte3 = fgetc(input);
    byte4 = fgetc(input);            
    sequence_list[i].lenght = (byte1 << 24) + (byte2 << 16) + (byte3 << 8) + byte4;
    
    }

    for (i = 0; i < seqcount; i++)   {
    
    if (i >= 0 && i <= 0x0F) {
        sprintf(filename, "seq_0%x", i); 
        }
        else
        {
        sprintf(filename, "seq_%x", i);             
    }
    
    FILE *ripped_file = fopen( filename , "w+b"); 
    
        fseek(input, (sequence_bank_offset + sequence_list[i].start_offset) , SEEK_SET);        
   
        for ( j = 0; j < sequence_list[i].lenght; j++)    {
        
            ch = getc(input);
            putc(ch, ripped_file);
            
            }

         fclose(ripped_file);
        
        }
        

}


/* entry-point */

int main ( int argc, char *argv[] )
{
    
if ( argc != 3 ) {
     
   printf(" \nSequence Bank ripper v0.1 by messiaen");         
   printf( "\nUsage: seq_rip.exe [file] [offset]" );
   printf( "\nExample: seq_rip.exe mario_us.z64 0x7B0860\n" );   
 
   } 
   
else 
   {

    int sbank_offset;
    sbank_offset = strtoul (argv[2],NULL,0);

    FILE *input_file = fopen( argv[1], "rb" );
   
    if (!(input_file == 0 ))  {
   
      if (!( check_file(input_file, sbank_offset) == 0) )   {                 
                    
         
                 
         fseek(input_file, (sbank_offset + 3), SEEK_SET);
         seq_count = fgetc(input_file);   
         printf("\nSequence Bank ripper v0.1 by messiaen");         
         printf("\nRipping %d sequences ... ", seq_count);
           
         rip_sequences(input_file, seq_count, sbank_offset);
         printf("done! \n");
         
         }
       
      else {
        
           printf ("\nNot a valid sequence bank offset.\n");
        
           }
    
      }
      
      else {
           
           printf ("\nError opening input file.\n");
        
           }      
      
    
   }
   
   
}
